/******************************************************************************* 
 * Copyright (c) 2007 Red Hat, Inc. 
 * Distributed under license by Red Hat, Inc. All rights reserved. 
 * This program is made available under the terms of the 
 * Eclipse Public License v1.0 which accompanies this distribution, 
 * and is available at http://www.eclipse.org/legal/epl-v10.html 
 * 
 * Contributors: 
 * Red Hat, Inc. - initial API and implementation 
 ******************************************************************************/ 
package org.jboss.tools.esb.core.model.converters;

import org.jboss.tools.common.model.XModelObject;

/**
 * Used for converting one complex property of out-of-the-box action.
 * 
 * Used for converting set of properties of FTP listener and other objects.
 * 
 * @author Viacheslav Kabanovich
 */
public interface IPropertyConverter {
	
	public void toSpecific(XModelObject basic, XModelObject specific);

	public void toBasic(XModelObject basic, XModelObject specific);

}
